lex = require "LuaEasyX"

--代码改自官网例子:https://www.codebus.cn/yangw/post/julia-set
--感谢作者分享的C代码

local initgraph = lex.DrawDevice.initgraph
local closegraph = lex.DrawDevice.closegraph
local putpixel = lex.Graphics.putpixel
local getch = lex.Event.KeyboardEvent.getch
local HSLtoRGB = lex.Color.HSLtoRGB

----------------------------------------------------


local win_width = 640
local win_height = 480


local function Main()
    initgraph(win_width, win_height)
    
    local z_re, z_im = 0, 0
    
    local c_re, c_im = -0.75, 0.006666
    
    --改变初始值可显示不同的形状
    --[[
    c_re, c_im = 0.45, -0.1428
    c_re, c_im = 0.285, 0.01
    c_re, c_im = 0.285, 0
    c_re, c_im = -0.8, 0.156
    c_re, c_im = -0.835, -0.2321
    c_re, c_im = -0.70176, -0.3842
    --]]
    
    local x, y, k = 0, 0, 0
    
    --Lua中的for再累加完变量后会将其置0
    
    for _x=0, win_width, 1 do
        if _x >= win_width then break end
        x=_x
        
        for _y=0, win_height, 1 do
            if _y>=win_height then break end
            y=_y
            
            z_re = -1.6 + 3.2 * (x / win_width)
            z_im = -1.2 + 2.4 * (y / win_height)
            
            for _k=0, 180, 1 do
                if _k >= 180 then k=_k break end
                k=_k
                if (z_re * z_re + z_im * z_im) > 4.0 then break end
                
                local r_re, r_im = 0.0, 0.0
                --z * z
                r_re = z_re*z_re - z_im*z_im
                r_im = z_im*z_re + z_re*z_im
                
                z_re = r_re + c_re
                z_im = r_im + c_im
            end
            
            local color
            if k>=180 then color = 0
            else color = HSLtoRGB((k << 5) % 360, 1.0, 0.5)
            end
            
            putpixel(x, y, color)
        end
    end
    
    getch()
    closegraph()
end


Main()

os.exit()

