lex = require "LuaEasyX"

---------------- Load functions ------------------------------------------
--DrawDevice
local initgraph = lex.DrawDevice.initgraph
local closegraph = lex.DrawDevice.closegraph
local cleardevice = lex.DrawDevice.cleardevice
--Event.KeyboardEvent
local getch = lex.Event.KeyboardEvent.getch
local kbhit = lex.Event.KeyboardEvent.kbhit
local FlushKeyboardBuffer = lex.Event.KeyboardEvent.FlushKeyboardBuffer
--Style
local setfillstyle = lex.Style.setfillstyle
local setlinestyle = lex.Style.setlinestyle
local setbkcolor = lex.Style.setbkcolor
local setbkmode = lex.Style.setbkmode
local setlinecolor = lex.Style.setlinecolor
local setfillcolor = lex.Style.setfillcolor
--Color
local RGB = lex.Color.RGB
--Graphics
local fillroundrect = lex.Graphics.fillroundrect
local fillpolygon = lex.Graphics.fillpolygon
local circle = lex.Graphics.circle
local POINT = lex.Graphics.POINT
--Image
local Image = lex.Image
local Resize = lex.Image.Resize
local putimage = lex.Image.putimage
--Text
local outtextxy = lex.Text.outtextxy
local settextstyle = lex.Text.settextstyle
--Extend
local bar3d = lex.Extend.bar3d
--WinGUI
local SetWindowText = lex.WinGUI.SetWindowText
local MessageBox = lex.WinGUI.MessageBox
--Constant
local MB_YESNO = lex.Constant.MB_YESNO
local MB_ICONEXCLAMATION = lex.Constant.MB_ICONEXCLAMATION
local IDOK = lex.Constant.IDOK
local IDNO = lex.Constant.IDNO
local MB_OK = lex.Constant.MB_OK
local BS_HATCHED = lex.Constant.BS_HATCHED
local HS_DIAGCROSS = lex.Constant.HS_DIAGCROSS
local PS_DASHDOTDOT = lex.Constant.PS_DASHDOTDOT
local BS_DIBPATTERN = lex.Constant.BS_DIBPATTERN
local VK_ESCAPE = lex.Constant.VK_ESCAPE
local VK_RETURN = lex.Constant.VK_RETURN
local CYAN = lex.Constant.CYAN
local LIGHTGRAY = lex.Constant.LIGHTGRAY
local TRANSPARENT = lex.Constant.TRANSPARENT
--builtin
local GetObjectAddress = lex.GetObjectAddress
------------------------------------------------------------------

-- to integer
local function int(f)
    if f >= 0 then return math.floor(f)
    else return math.ceil(f)
    end
end

------------------------------------------------

local win_width = 640
local win_height = 480


local function Main(args)
    hwnd, err = initgraph(win_width, win_height)
    SetWindowText(hwnd, "lua: setcliprgn.lua")
    
    setbkcolor(LIGHTGRAY)
    setbkmode(TRANSPARENT)
    cleardevice()
    
    
    bar3d(10, 400, 100, 80, 50, true)
    
    setfillstyle(BS_HATCHED, HS_DIAGCROSS)
    setlinestyle(PS_DASHDOTDOT, 2)
    
    
    setfillcolor(RGB(111, 222, 77))
    setlinecolor(CYAN)
    
    fillroundrect(50, 50, 300, 200, 30, 30)
    
    
    local img = Image("666.jpg")
    local pImg = GetObjectAddress(img)
    
    local width, height = img:getimagesize()
    
    outtextxy(500, 10, "width: "..width)
    outtextxy(500, 40, "height: "..height)
    
    setfillstyle(BS_DIBPATTERN, nil, pImg)
    
    local points = {
        {310, 360},
        {400, 400},
        {440, 300},
        {300, 300},
        {200, 200}
    }
    
    local pointset, num = POINT(points)
    local pPoints = GetObjectAddress(pointset)
    
    
    fillpolygon(pPoints, num)
    
    Resize(pImg, 100, 100)
    
    putimage(400, 100, pImg)
    
    local times = 0
    
    while true do
        if kbhit() == true then
            local k = getch()
            if k == VK_ESCAPE then  --ESC
                break
            else if k == VK_RETURN then  --س
                local str, yn = lex.Option.InputBox(
                    256,
                    "ɶ˵ģ",
                    "*Ի*",
                    "~~~",
                    0, 0,
                    false
                )
                
                if yn == true then
                    local ret = MessageBox(
                        hwnd,
                        "ˣ"..str,
                        "",
                        MB_ICONEXCLAMATION|MB_YESNO
                    )
                    
                    if ret == IDOK then
                        times = times + 1
                        SetWindowText(hwnd, "Ϻx"..times)
                    else
                        times = times + 1
                        SetWindowText(hwnd, "x"..times)
                    end
                else
                    MessageBox(hwnd, "ѡȡ~", "ѡɶ", MB_OK)
                end
                
            end
            FlushKeyboardBuffer()
            end
        end
        lex.sleep(10)
    end
    
    img = nil
    pointset = nil
    
    closegraph()
end

Main()

os.exit()

