
#include "Constant.h"



#define MAKELUAEASYXCONSTANT(name) {#name, name}

const struct LuaEasyX_Constant lex_constant_elements[] =  {
    /* initgraph */
    MAKELUAEASYXCONSTANT(NOCLOSE),
    MAKELUAEASYXCONSTANT(NOMINIMIZE),
    MAKELUAEASYXCONSTANT(SHOWCONSOLE),

    /* setbkmode */
    MAKELUAEASYXCONSTANT(OPAQUE),
    MAKELUAEASYXCONSTANT(TRANSPARENT),

    /* setfillstyle */
    MAKELUAEASYXCONSTANT(BS_SOLID),
    MAKELUAEASYXCONSTANT(BS_NULL),
    MAKELUAEASYXCONSTANT(BS_HATCHED),
    MAKELUAEASYXCONSTANT(BS_PATTERN),
    MAKELUAEASYXCONSTANT(BS_DIBPATTERN),
    MAKELUAEASYXCONSTANT(HS_HORIZONTAL),
    MAKELUAEASYXCONSTANT(HS_VERTICAL),
    MAKELUAEASYXCONSTANT(HS_FDIAGONAL),
    MAKELUAEASYXCONSTANT(HS_BDIAGONAL),
    MAKELUAEASYXCONSTANT(HS_CROSS),
    MAKELUAEASYXCONSTANT(HS_DIAGCROSS),

    /* setlinestyle */
    MAKELUAEASYXCONSTANT(PS_SOLID),
    MAKELUAEASYXCONSTANT(PS_DASH),
    MAKELUAEASYXCONSTANT(PS_DOT),
    MAKELUAEASYXCONSTANT(PS_DASHDOT),
    MAKELUAEASYXCONSTANT(PS_DASHDOTDOT),
    MAKELUAEASYXCONSTANT(PS_NULL),
    MAKELUAEASYXCONSTANT(PS_USERSTYLE),
    MAKELUAEASYXCONSTANT(PS_ENDCAP_ROUND),
    MAKELUAEASYXCONSTANT(PS_ENDCAP_SQUARE),
    MAKELUAEASYXCONSTANT(PS_ENDCAP_FLAT),
    MAKELUAEASYXCONSTANT(PS_JOIN_BEVEL),
    MAKELUAEASYXCONSTANT(PS_JOIN_MITER),
    MAKELUAEASYXCONSTANT(PS_JOIN_ROUND),
    MAKELUAEASYXCONSTANT(PS_STYLE_MASK),
    MAKELUAEASYXCONSTANT(PS_ENDCAP_MASK),
    MAKELUAEASYXCONSTANT(PS_JOIN_MASK),

    /* setpolyfillmode */
    MAKELUAEASYXCONSTANT(ALTERNATE),
    MAKELUAEASYXCONSTANT(WINDING),

    /* setrop2 */
    MAKELUAEASYXCONSTANT(R2_BLACK),
    MAKELUAEASYXCONSTANT(R2_COPYPEN),
    MAKELUAEASYXCONSTANT(R2_MASKNOTPEN),
    MAKELUAEASYXCONSTANT(R2_MASKPEN),
    MAKELUAEASYXCONSTANT(R2_MASKPENNOT),
    MAKELUAEASYXCONSTANT(R2_MERGENOTPEN),
    MAKELUAEASYXCONSTANT(R2_MERGEPEN),
    MAKELUAEASYXCONSTANT(R2_MERGEPENNOT),
    MAKELUAEASYXCONSTANT(R2_NOP),
    MAKELUAEASYXCONSTANT(R2_NOT),
    MAKELUAEASYXCONSTANT(R2_NOTCOPYPEN),
    MAKELUAEASYXCONSTANT(R2_NOTMASKPEN),
    MAKELUAEASYXCONSTANT(R2_NOTMERGEPEN),
    MAKELUAEASYXCONSTANT(R2_NOTXORPEN),
    MAKELUAEASYXCONSTANT(R2_WHITE),
    MAKELUAEASYXCONSTANT(R2_XORPEN),

    /* floodfill */
    MAKELUAEASYXCONSTANT(FLOODFILLBORDER),
    MAKELUAEASYXCONSTANT(FLOODFILLSURFACE),

    /* drawtext */
    MAKELUAEASYXCONSTANT(DT_BOTTOM),
    MAKELUAEASYXCONSTANT(DT_CALCRECT),
    MAKELUAEASYXCONSTANT(DT_CENTER),
    MAKELUAEASYXCONSTANT(DT_EDITCONTROL),
    MAKELUAEASYXCONSTANT(DT_END_ELLIPSIS),
    MAKELUAEASYXCONSTANT(DT_EXPANDTABS),
    MAKELUAEASYXCONSTANT(DT_EXTERNALLEADING),
    MAKELUAEASYXCONSTANT(DT_HIDEPREFIX),
    MAKELUAEASYXCONSTANT(DT_INTERNAL),
    MAKELUAEASYXCONSTANT(DT_LEFT),
    MAKELUAEASYXCONSTANT(DT_MODIFYSTRING),
    MAKELUAEASYXCONSTANT(DT_NOCLIP),
    MAKELUAEASYXCONSTANT(DT_NOFULLWIDTHCHARBREAK),
    MAKELUAEASYXCONSTANT(DT_NOPREFIX),
    MAKELUAEASYXCONSTANT(DT_PATH_ELLIPSIS),
    MAKELUAEASYXCONSTANT(DT_PREFIXONLY),
    MAKELUAEASYXCONSTANT(DT_RIGHT),
    MAKELUAEASYXCONSTANT(DT_RTLREADING),
    MAKELUAEASYXCONSTANT(DT_SINGLELINE),
    MAKELUAEASYXCONSTANT(DT_TABSTOP),
    MAKELUAEASYXCONSTANT(DT_TOP),
    MAKELUAEASYXCONSTANT(DT_VCENTER),
    MAKELUAEASYXCONSTANT(DT_WORDBREAK),
    MAKELUAEASYXCONSTANT(DT_WORD_ELLIPSIS),

    /* struct LOGFONT */
    MAKELUAEASYXCONSTANT(FW_DONTCARE),
    MAKELUAEASYXCONSTANT(FW_THIN),
    MAKELUAEASYXCONSTANT(FW_EXTRALIGHT),
    MAKELUAEASYXCONSTANT(FW_ULTRALIGHT),
    MAKELUAEASYXCONSTANT(FW_LIGHT),
    MAKELUAEASYXCONSTANT(FW_NORMAL),
    MAKELUAEASYXCONSTANT(FW_REGULAR),
    MAKELUAEASYXCONSTANT(FW_MEDIUM),
    MAKELUAEASYXCONSTANT(FW_SEMIBOLD),
    MAKELUAEASYXCONSTANT(FW_DEMIBOLD),
    MAKELUAEASYXCONSTANT(FW_BOLD),
    MAKELUAEASYXCONSTANT(FW_EXTRABOLD),
    MAKELUAEASYXCONSTANT(FW_ULTRABOLD),
    MAKELUAEASYXCONSTANT(FW_HEAVY),
    MAKELUAEASYXCONSTANT(FW_BLACK),
    MAKELUAEASYXCONSTANT(ANSI_CHARSET),
    MAKELUAEASYXCONSTANT(BALTIC_CHARSET),
    MAKELUAEASYXCONSTANT(CHINESEBIG5_CHARSET),
    MAKELUAEASYXCONSTANT(DEFAULT_CHARSET),
    MAKELUAEASYXCONSTANT(EASTEUROPE_CHARSET),
    MAKELUAEASYXCONSTANT(GB2312_CHARSET),
    MAKELUAEASYXCONSTANT(GREEK_CHARSET),
    MAKELUAEASYXCONSTANT(HANGUL_CHARSET),
    MAKELUAEASYXCONSTANT(MAC_CHARSET),
    MAKELUAEASYXCONSTANT(OEM_CHARSET),
    MAKELUAEASYXCONSTANT(RUSSIAN_CHARSET),
    MAKELUAEASYXCONSTANT(SHIFTJIS_CHARSET),
    MAKELUAEASYXCONSTANT(SYMBOL_CHARSET),
    MAKELUAEASYXCONSTANT(TURKISH_CHARSET),
    MAKELUAEASYXCONSTANT(OUT_DEFAULT_PRECIS),
    MAKELUAEASYXCONSTANT(OUT_DEVICE_PRECIS),
    MAKELUAEASYXCONSTANT(OUT_OUTLINE_PRECIS),
    MAKELUAEASYXCONSTANT(OUT_RASTER_PRECIS),
    MAKELUAEASYXCONSTANT(OUT_STRING_PRECIS),
    MAKELUAEASYXCONSTANT(OUT_STROKE_PRECIS),
    MAKELUAEASYXCONSTANT(OUT_TT_ONLY_PRECIS),
    MAKELUAEASYXCONSTANT(OUT_TT_PRECIS),
    MAKELUAEASYXCONSTANT(CLIP_DEFAULT_PRECIS),
    MAKELUAEASYXCONSTANT(CLIP_STROKE_PRECIS),
    MAKELUAEASYXCONSTANT(CLIP_EMBEDDED),
    MAKELUAEASYXCONSTANT(CLIP_LH_ANGLES),
    MAKELUAEASYXCONSTANT(ANTIALIASED_QUALITY),
    MAKELUAEASYXCONSTANT(DEFAULT_QUALITY),
    MAKELUAEASYXCONSTANT(DRAFT_QUALITY),
    MAKELUAEASYXCONSTANT(NONANTIALIASED_QUALITY),
    MAKELUAEASYXCONSTANT(PROOF_QUALITY),
    MAKELUAEASYXCONSTANT(DEFAULT_PITCH),
    MAKELUAEASYXCONSTANT(FIXED_PITCH),
    MAKELUAEASYXCONSTANT(VARIABLE_PITCH),
    MAKELUAEASYXCONSTANT(FF_DECORATIVE),
    MAKELUAEASYXCONSTANT(FF_DONTCARE),
    MAKELUAEASYXCONSTANT(FF_MODERN),
    MAKELUAEASYXCONSTANT(FF_ROMAN),
    MAKELUAEASYXCONSTANT(FF_SCRIPT),
    MAKELUAEASYXCONSTANT(FF_SWISS),
    MAKELUAEASYXCONSTANT(LF_FACESIZE),

    /* putimage */
    MAKELUAEASYXCONSTANT(DSTINVERT),
    MAKELUAEASYXCONSTANT(MERGECOPY),
    MAKELUAEASYXCONSTANT(MERGEPAINT),
    MAKELUAEASYXCONSTANT(NOTSRCCOPY),
    MAKELUAEASYXCONSTANT(NOTSRCERASE),
    MAKELUAEASYXCONSTANT(PATCOPY),
    MAKELUAEASYXCONSTANT(PATINVERT),
    MAKELUAEASYXCONSTANT(PATPAINT),
    MAKELUAEASYXCONSTANT(SRCAND),
    MAKELUAEASYXCONSTANT(SRCCOPY),
    MAKELUAEASYXCONSTANT(SRCERASE),
    MAKELUAEASYXCONSTANT(SRCINVERT),
    MAKELUAEASYXCONSTANT(SRCPAINT),

    /* struct MOUSEMSG */
    MAKELUAEASYXCONSTANT(WM_MOUSEMOVE),
    MAKELUAEASYXCONSTANT(WM_MOUSEWHEEL),
    MAKELUAEASYXCONSTANT(WM_LBUTTONDOWN),
    MAKELUAEASYXCONSTANT(WM_LBUTTONUP),
    MAKELUAEASYXCONSTANT(WM_LBUTTONDBLCLK),
    MAKELUAEASYXCONSTANT(WM_MBUTTONDOWN),
    MAKELUAEASYXCONSTANT(WM_MBUTTONUP),
    MAKELUAEASYXCONSTANT(WM_MBUTTONDBLCLK),
    MAKELUAEASYXCONSTANT(WM_RBUTTONDOWN),
    MAKELUAEASYXCONSTANT(WM_RBUTTONUP),
    MAKELUAEASYXCONSTANT(WM_RBUTTONDBLCLK),

    /* MessageBox */
    MAKELUAEASYXCONSTANT(MB_ABORTRETRYIGNORE),
    MAKELUAEASYXCONSTANT(MB_CANCELTRYCONTINUE),
    MAKELUAEASYXCONSTANT(MB_HELP),
    MAKELUAEASYXCONSTANT(MB_OK),
    MAKELUAEASYXCONSTANT(MB_OKCANCEL),
    MAKELUAEASYXCONSTANT(MB_RETRYCANCEL),
    MAKELUAEASYXCONSTANT(MB_YESNO),
    MAKELUAEASYXCONSTANT(MB_YESNOCANCEL),
    MAKELUAEASYXCONSTANT(MB_ICONEXCLAMATION),
    MAKELUAEASYXCONSTANT(MB_ICONWARNING),
    MAKELUAEASYXCONSTANT(MB_ICONINFORMATION),
    MAKELUAEASYXCONSTANT(MB_ICONASTERISK),
    MAKELUAEASYXCONSTANT(MB_ICONQUESTION),
    MAKELUAEASYXCONSTANT(MB_ICONSTOP),
    MAKELUAEASYXCONSTANT(MB_ICONERROR),
    MAKELUAEASYXCONSTANT(MB_ICONHAND),
    MAKELUAEASYXCONSTANT(MB_DEFBUTTON1),
    MAKELUAEASYXCONSTANT(MB_DEFBUTTON2),
    MAKELUAEASYXCONSTANT(MB_DEFBUTTON3),
    MAKELUAEASYXCONSTANT(MB_DEFBUTTON4),
    MAKELUAEASYXCONSTANT(MB_APPLMODAL),
    MAKELUAEASYXCONSTANT(MB_SYSTEMMODAL),
    MAKELUAEASYXCONSTANT(MB_TASKMODAL),
    MAKELUAEASYXCONSTANT(MB_DEFAULT_DESKTOP_ONLY),
    MAKELUAEASYXCONSTANT(MB_RIGHT),
    MAKELUAEASYXCONSTANT(MB_RTLREADING),
    MAKELUAEASYXCONSTANT(MB_SETFOREGROUND),
    MAKELUAEASYXCONSTANT(MB_TOPMOST),
    MAKELUAEASYXCONSTANT(MB_SERVICE_NOTIFICATION),
    MAKELUAEASYXCONSTANT(IDABORT),
    MAKELUAEASYXCONSTANT(IDCANCEL),
    MAKELUAEASYXCONSTANT(IDCONTINUE),
    MAKELUAEASYXCONSTANT(IDIGNORE),
    MAKELUAEASYXCONSTANT(IDNO),
    MAKELUAEASYXCONSTANT(IDOK),
    MAKELUAEASYXCONSTANT(IDRETRY),
    MAKELUAEASYXCONSTANT(IDTRYAGAIN),
    MAKELUAEASYXCONSTANT(IDYES),


    /* RGB */

    #define COLOR_RGB(color) {#color, color}

    COLOR_RGB(BLACK),
    COLOR_RGB(BLUE),
    COLOR_RGB(GREEN),
    COLOR_RGB(CYAN),
    COLOR_RGB(RED),
    COLOR_RGB(MAGENTA),
    COLOR_RGB(BROWN),
    COLOR_RGB(LIGHTGRAY),
    COLOR_RGB(DARKGRAY),
    COLOR_RGB(LIGHTBLUE),
    COLOR_RGB(LIGHTGREEN),
    COLOR_RGB(LIGHTCYAN),
    COLOR_RGB(LIGHTRED),
    COLOR_RGB(LIGHTMAGENTA),
    COLOR_RGB(YELLOW),
    COLOR_RGB(WHITE),

    /* HRGN */
    MAKELUAEASYXCONSTANT(ALTERNATE),
    MAKELUAEASYXCONSTANT(WINDING),
    MAKELUAEASYXCONSTANT(RGN_AND),
    MAKELUAEASYXCONSTANT(RGN_COPY),
    MAKELUAEASYXCONSTANT(RGN_DIFF),
    MAKELUAEASYXCONSTANT(RGN_OR),
    MAKELUAEASYXCONSTANT(RGN_XOR),
    MAKELUAEASYXCONSTANT(NULLREGION),
    MAKELUAEASYXCONSTANT(SIMPLEREGION),
    MAKELUAEASYXCONSTANT(COMPLEXREGION),
    MAKELUAEASYXCONSTANT(ERROR),

    /* Virtual-Key Codes */
    MAKELUAEASYXCONSTANT(VK_LBUTTON),
    MAKELUAEASYXCONSTANT(VK_RBUTTON),
    MAKELUAEASYXCONSTANT(VK_CANCEL),
    MAKELUAEASYXCONSTANT(VK_MBUTTON),
    MAKELUAEASYXCONSTANT(VK_XBUTTON1),
    MAKELUAEASYXCONSTANT(VK_XBUTTON2),
    MAKELUAEASYXCONSTANT(VK_BACK),
    MAKELUAEASYXCONSTANT(VK_BACK),
    MAKELUAEASYXCONSTANT(VK_TAB),
    MAKELUAEASYXCONSTANT(VK_CLEAR),
    MAKELUAEASYXCONSTANT(VK_RETURN),
    MAKELUAEASYXCONSTANT(VK_SHIFT),
    MAKELUAEASYXCONSTANT(VK_CONTROL),
    MAKELUAEASYXCONSTANT(VK_MENU),
    MAKELUAEASYXCONSTANT(VK_PAUSE),
    MAKELUAEASYXCONSTANT(VK_CAPITAL),
    MAKELUAEASYXCONSTANT(VK_KANA),
    MAKELUAEASYXCONSTANT(VK_HANGUEL),
    MAKELUAEASYXCONSTANT(VK_HANGUL),
    MAKELUAEASYXCONSTANT(VK_JUNJA),
    MAKELUAEASYXCONSTANT(VK_FINAL),
    MAKELUAEASYXCONSTANT(VK_HANJA),
    MAKELUAEASYXCONSTANT(VK_KANJI),
    MAKELUAEASYXCONSTANT(VK_ESCAPE),
    MAKELUAEASYXCONSTANT(VK_CONVERT),
    MAKELUAEASYXCONSTANT(VK_NONCONVERT),
    MAKELUAEASYXCONSTANT(VK_ACCEPT),
    MAKELUAEASYXCONSTANT(VK_MODECHANGE),
    MAKELUAEASYXCONSTANT(VK_SPACE),
    MAKELUAEASYXCONSTANT(VK_PRIOR),
    MAKELUAEASYXCONSTANT(VK_NEXT),
    MAKELUAEASYXCONSTANT(VK_END),
    MAKELUAEASYXCONSTANT(VK_HOME),
    MAKELUAEASYXCONSTANT(VK_LEFT),
    MAKELUAEASYXCONSTANT(VK_UP),
    MAKELUAEASYXCONSTANT(VK_RIGHT),
    MAKELUAEASYXCONSTANT(VK_DOWN),
    MAKELUAEASYXCONSTANT(VK_SELECT),
    MAKELUAEASYXCONSTANT(VK_PRINT),
    MAKELUAEASYXCONSTANT(VK_EXECUTE),
    MAKELUAEASYXCONSTANT(VK_SNAPSHOT),
    MAKELUAEASYXCONSTANT(VK_INSERT),
    MAKELUAEASYXCONSTANT(VK_DELETE),
    MAKELUAEASYXCONSTANT(VK_HELP),
    MAKELUAEASYXCONSTANT(VK_LWIN),
    MAKELUAEASYXCONSTANT(VK_RWIN),
    MAKELUAEASYXCONSTANT(VK_APPS),
    MAKELUAEASYXCONSTANT(VK_SLEEP),
    MAKELUAEASYXCONSTANT(VK_NUMPAD0),
    MAKELUAEASYXCONSTANT(VK_NUMPAD1),
    MAKELUAEASYXCONSTANT(VK_NUMPAD2),
    MAKELUAEASYXCONSTANT(VK_NUMPAD3),
    MAKELUAEASYXCONSTANT(VK_NUMPAD4),
    MAKELUAEASYXCONSTANT(VK_NUMPAD5),
    MAKELUAEASYXCONSTANT(VK_NUMPAD6),
    MAKELUAEASYXCONSTANT(VK_NUMPAD7),
    MAKELUAEASYXCONSTANT(VK_NUMPAD8),
    MAKELUAEASYXCONSTANT(VK_NUMPAD9),
    MAKELUAEASYXCONSTANT(VK_MULTIPLY),
    MAKELUAEASYXCONSTANT(VK_ADD),
    MAKELUAEASYXCONSTANT(VK_SEPARATOR),
    MAKELUAEASYXCONSTANT(VK_SUBTRACT),
    MAKELUAEASYXCONSTANT(VK_DECIMAL),
    MAKELUAEASYXCONSTANT(VK_DIVIDE),
    MAKELUAEASYXCONSTANT(VK_F1),
    MAKELUAEASYXCONSTANT(VK_F2),
    MAKELUAEASYXCONSTANT(VK_F3),
    MAKELUAEASYXCONSTANT(VK_F4),
    MAKELUAEASYXCONSTANT(VK_F5),
    MAKELUAEASYXCONSTANT(VK_F6),
    MAKELUAEASYXCONSTANT(VK_F7),
    MAKELUAEASYXCONSTANT(VK_F8),
    MAKELUAEASYXCONSTANT(VK_F9),
    MAKELUAEASYXCONSTANT(VK_F10),
    MAKELUAEASYXCONSTANT(VK_F11),
    MAKELUAEASYXCONSTANT(VK_F12),
    MAKELUAEASYXCONSTANT(VK_F13),
    MAKELUAEASYXCONSTANT(VK_F14),
    MAKELUAEASYXCONSTANT(VK_F15),
    MAKELUAEASYXCONSTANT(VK_F16),
    MAKELUAEASYXCONSTANT(VK_F17),
    MAKELUAEASYXCONSTANT(VK_F18),
    MAKELUAEASYXCONSTANT(VK_F19),
    MAKELUAEASYXCONSTANT(VK_F20),
    MAKELUAEASYXCONSTANT(VK_F21),
    MAKELUAEASYXCONSTANT(VK_F22),
    MAKELUAEASYXCONSTANT(VK_F23),
    MAKELUAEASYXCONSTANT(VK_F24),
    MAKELUAEASYXCONSTANT(VK_NUMLOCK),
    MAKELUAEASYXCONSTANT(VK_SCROLL),
    MAKELUAEASYXCONSTANT(VK_LSHIFT),
    MAKELUAEASYXCONSTANT(VK_RSHIFT),
    MAKELUAEASYXCONSTANT(VK_LCONTROL),
    MAKELUAEASYXCONSTANT(VK_RCONTROL),
    MAKELUAEASYXCONSTANT(VK_LMENU),
    MAKELUAEASYXCONSTANT(VK_RMENU),
    MAKELUAEASYXCONSTANT(VK_BROWSER_BACK),
    MAKELUAEASYXCONSTANT(VK_BROWSER_FORWARD),
    MAKELUAEASYXCONSTANT(VK_BROWSER_REFRESH),
    MAKELUAEASYXCONSTANT(VK_BROWSER_STOP),
    MAKELUAEASYXCONSTANT(VK_BROWSER_SEARCH),
    MAKELUAEASYXCONSTANT(VK_BROWSER_FAVORITES),
    MAKELUAEASYXCONSTANT(VK_BROWSER_HOME),
    MAKELUAEASYXCONSTANT(VK_VOLUME_MUTE),
    MAKELUAEASYXCONSTANT(VK_VOLUME_DOWN),
    MAKELUAEASYXCONSTANT(VK_VOLUME_UP),
    MAKELUAEASYXCONSTANT(VK_MEDIA_NEXT_TRACK),
    MAKELUAEASYXCONSTANT(VK_MEDIA_PREV_TRACK),
    MAKELUAEASYXCONSTANT(VK_MEDIA_STOP),
    MAKELUAEASYXCONSTANT(VK_MEDIA_PLAY_PAUSE),
    MAKELUAEASYXCONSTANT(VK_LAUNCH_MAIL),
    MAKELUAEASYXCONSTANT(VK_LAUNCH_MEDIA_SELECT),
    MAKELUAEASYXCONSTANT(VK_LAUNCH_APP1),
    MAKELUAEASYXCONSTANT(VK_LAUNCH_APP2),
    MAKELUAEASYXCONSTANT(VK_OEM_1),
    MAKELUAEASYXCONSTANT(VK_OEM_PLUS),
    MAKELUAEASYXCONSTANT(VK_OEM_COMMA),
    MAKELUAEASYXCONSTANT(VK_OEM_MINUS),
    MAKELUAEASYXCONSTANT(VK_OEM_PERIOD),
    MAKELUAEASYXCONSTANT(VK_OEM_2),
    MAKELUAEASYXCONSTANT(VK_OEM_3),
    MAKELUAEASYXCONSTANT(VK_OEM_4),
    MAKELUAEASYXCONSTANT(VK_OEM_5),
    MAKELUAEASYXCONSTANT(VK_OEM_6),
    MAKELUAEASYXCONSTANT(VK_OEM_7),
    MAKELUAEASYXCONSTANT(VK_OEM_8),
    MAKELUAEASYXCONSTANT(VK_OEM_102),
    MAKELUAEASYXCONSTANT(VK_PROCESSKEY),
    MAKELUAEASYXCONSTANT(VK_PACKET),
    MAKELUAEASYXCONSTANT(VK_ATTN),
    MAKELUAEASYXCONSTANT(VK_CRSEL),
    MAKELUAEASYXCONSTANT(VK_EXSEL),
    MAKELUAEASYXCONSTANT(VK_EREOF),
    MAKELUAEASYXCONSTANT(VK_PLAY),
    MAKELUAEASYXCONSTANT(VK_ZOOM),
    MAKELUAEASYXCONSTANT(VK_NONAME),
    MAKELUAEASYXCONSTANT(VK_PA1),
    MAKELUAEASYXCONSTANT(VK_OEM_CLEAR),

    /* GetSystemMetrics */
    MAKELUAEASYXCONSTANT(SM_ARRANGE),
    MAKELUAEASYXCONSTANT(SM_CLEANBOOT),
    MAKELUAEASYXCONSTANT(SM_CMONITORS),
    MAKELUAEASYXCONSTANT(SM_CMOUSEBUTTONS),
    MAKELUAEASYXCONSTANT(SM_CONVERTIBLESLATEMODE),
    MAKELUAEASYXCONSTANT(SM_CXBORDER),
    MAKELUAEASYXCONSTANT(SM_CXCURSOR),
    MAKELUAEASYXCONSTANT(SM_CXDLGFRAME),
    MAKELUAEASYXCONSTANT(SM_CXDOUBLECLK),
    MAKELUAEASYXCONSTANT(SM_CXDRAG),
    MAKELUAEASYXCONSTANT(SM_CXEDGE),
    MAKELUAEASYXCONSTANT(SM_CXFIXEDFRAME),
    MAKELUAEASYXCONSTANT(SM_CXFOCUSBORDER),
    MAKELUAEASYXCONSTANT(SM_CXFRAME),
    MAKELUAEASYXCONSTANT(SM_CXFULLSCREEN),
    MAKELUAEASYXCONSTANT(SM_CXHSCROLL),
    MAKELUAEASYXCONSTANT(SM_CXHTHUMB),
    MAKELUAEASYXCONSTANT(SM_CXICON),
    MAKELUAEASYXCONSTANT(SM_CXICONSPACING),
    MAKELUAEASYXCONSTANT(SM_CXMAXIMIZED),
    MAKELUAEASYXCONSTANT(SM_CXMAXTRACK),
    MAKELUAEASYXCONSTANT(SM_CXMENUCHECK),
    MAKELUAEASYXCONSTANT(SM_CXMENUSIZE),
    MAKELUAEASYXCONSTANT(SM_CXMIN),
    MAKELUAEASYXCONSTANT(SM_CXMINIMIZED),
    MAKELUAEASYXCONSTANT(SM_CXMINSPACING),
    MAKELUAEASYXCONSTANT(SM_CXMINTRACK),
    MAKELUAEASYXCONSTANT(SM_CXPADDEDBORDER),
    MAKELUAEASYXCONSTANT(SM_CXSCREEN),
    MAKELUAEASYXCONSTANT(SM_CXSIZE),
    MAKELUAEASYXCONSTANT(SM_CXSIZEFRAME),
    MAKELUAEASYXCONSTANT(SM_CXSMICON),
    MAKELUAEASYXCONSTANT(SM_CXSMSIZE),
    MAKELUAEASYXCONSTANT(SM_CXVIRTUALSCREEN),
    MAKELUAEASYXCONSTANT(SM_CXVSCROLL),
    MAKELUAEASYXCONSTANT(SM_CYBORDER),
    MAKELUAEASYXCONSTANT(SM_CYCAPTION),
    MAKELUAEASYXCONSTANT(SM_CYCURSOR),
    MAKELUAEASYXCONSTANT(SM_CYDLGFRAME),
    MAKELUAEASYXCONSTANT(SM_CYDOUBLECLK),
    MAKELUAEASYXCONSTANT(SM_CYDRAG),
    MAKELUAEASYXCONSTANT(SM_CYEDGE),
    MAKELUAEASYXCONSTANT(SM_CYFIXEDFRAME),
    MAKELUAEASYXCONSTANT(SM_CYFOCUSBORDER),
    MAKELUAEASYXCONSTANT(SM_CYFRAME),
    MAKELUAEASYXCONSTANT(SM_CYFULLSCREEN),
    MAKELUAEASYXCONSTANT(SM_CYHSCROLL),
    MAKELUAEASYXCONSTANT(SM_CYICON),
    MAKELUAEASYXCONSTANT(SM_CYICONSPACING),
    MAKELUAEASYXCONSTANT(SM_CYKANJIWINDOW),
    MAKELUAEASYXCONSTANT(SM_CYMAXIMIZED),
    MAKELUAEASYXCONSTANT(SM_CYMAXTRACK),
    MAKELUAEASYXCONSTANT(SM_CYMENU),
    MAKELUAEASYXCONSTANT(SM_CYMENUCHECK),
    MAKELUAEASYXCONSTANT(SM_CYMENUSIZE),
    MAKELUAEASYXCONSTANT(SM_CYMIN),
    MAKELUAEASYXCONSTANT(SM_CYMINIMIZED),
    MAKELUAEASYXCONSTANT(SM_CYMINSPACING),
    MAKELUAEASYXCONSTANT(SM_CYMINTRACK),
    MAKELUAEASYXCONSTANT(SM_CYSCREEN),
    MAKELUAEASYXCONSTANT(SM_CYSIZE),
    MAKELUAEASYXCONSTANT(SM_CYSIZEFRAME),
    MAKELUAEASYXCONSTANT(SM_CYSMCAPTION),
    MAKELUAEASYXCONSTANT(SM_CYSMICON),
    MAKELUAEASYXCONSTANT(SM_CYSMSIZE),
    MAKELUAEASYXCONSTANT(SM_CYVIRTUALSCREEN),
    MAKELUAEASYXCONSTANT(SM_CYVSCROLL),
    MAKELUAEASYXCONSTANT(SM_CYVTHUMB),
    MAKELUAEASYXCONSTANT(SM_DBCSENABLED),
    MAKELUAEASYXCONSTANT(SM_DEBUG),
    MAKELUAEASYXCONSTANT(SM_DIGITIZER),
    MAKELUAEASYXCONSTANT(SM_IMMENABLED),
    MAKELUAEASYXCONSTANT(SM_MAXIMUMTOUCHES),
    MAKELUAEASYXCONSTANT(SM_MEDIACENTER),
    MAKELUAEASYXCONSTANT(SM_MENUDROPALIGNMENT),
    MAKELUAEASYXCONSTANT(SM_MIDEASTENABLED),
    MAKELUAEASYXCONSTANT(SM_MOUSEPRESENT),
    MAKELUAEASYXCONSTANT(SM_MOUSEHORIZONTALWHEELPRESENT),
    MAKELUAEASYXCONSTANT(SM_MOUSEWHEELPRESENT),
    MAKELUAEASYXCONSTANT(SM_NETWORK),
    MAKELUAEASYXCONSTANT(SM_PENWINDOWS),
    MAKELUAEASYXCONSTANT(SM_REMOTECONTROL),
    MAKELUAEASYXCONSTANT(SM_REMOTESESSION),
    MAKELUAEASYXCONSTANT(SM_SAMEDISPLAYFORMAT),
    MAKELUAEASYXCONSTANT(SM_SECURE),
    MAKELUAEASYXCONSTANT(SM_SERVERR2),
    MAKELUAEASYXCONSTANT(SM_SHOWSOUNDS),
    MAKELUAEASYXCONSTANT(SM_SHUTTINGDOWN),
    MAKELUAEASYXCONSTANT(SM_SLOWMACHINE),
    MAKELUAEASYXCONSTANT(SM_STARTER),
    MAKELUAEASYXCONSTANT(SM_SWAPBUTTON),
    MAKELUAEASYXCONSTANT(SM_SYSTEMDOCKED),
    MAKELUAEASYXCONSTANT(SM_TABLETPC),
    MAKELUAEASYXCONSTANT(SM_XVIRTUALSCREEN),
    MAKELUAEASYXCONSTANT(SM_YVIRTUALSCREEN),

    /* MapVirtualKey */
    MAKELUAEASYXCONSTANT(MAPVK_VK_TO_CHAR),
    MAKELUAEASYXCONSTANT(MAPVK_VK_TO_VSC),
    MAKELUAEASYXCONSTANT(MAPVK_VSC_TO_VK),
    MAKELUAEASYXCONSTANT(MAPVK_VSC_TO_VK_EX),

    /* mciSendString  */
    MAKELUAEASYXCONSTANT(MCIERR_BAD_CONSTANT),
    MAKELUAEASYXCONSTANT(MCIERR_BAD_INTEGER),
    MAKELUAEASYXCONSTANT(MCIERR_DUPLICATE_FLAGS),
    MAKELUAEASYXCONSTANT(MCIERR_MISSING_COMMAND_STRING),
    MAKELUAEASYXCONSTANT(MCIERR_MISSING_DEVICE_NAME),
    MAKELUAEASYXCONSTANT(MCIERR_MISSING_STRING_ARGUMENT),
    MAKELUAEASYXCONSTANT(MCIERR_NEW_REQUIRES_ALIAS),
    MAKELUAEASYXCONSTANT(MCIERR_NO_CLOSING_QUOTE),
    MAKELUAEASYXCONSTANT(MCIERR_NOTIFY_ON_AUTO_OPEN),
    MAKELUAEASYXCONSTANT(MCIERR_PARAM_OVERFLOW),
    MAKELUAEASYXCONSTANT(MCIERR_PARSER_INTERNAL),
    MAKELUAEASYXCONSTANT(MCIERR_UNRECOGNIZED_KEYWORD),
    //MAKELUAEASYXCONSTANT(),
    {NULL, NULL}
};



TCHAR* ConstantClassName = TEXT("LuaEasyX_Constant");


int l_GetConstantByName(lua_State* L) {
    int top = lua_gettop(L);
    if (top > 0) {
        if (luaL_getmetatable(L, ConstantClassName)) {
            lua_pushnil(L);
            lua_copy(L, top, -1);
            lua_rawget(L, -2);
        } else {
            return 0;
        }
    } else {
        return 0;
    }

    return 1;
}


int CreateConstant(lua_State* L) {

    int top = lua_gettop(L);

    BOOL bIsNew;

    int ret = c_comment_metatable(L,
        ConstantClassName,
        NULL,
        LUAEASYX_STRUCTTYP_NONETYPE,
        &bIsNew,
        NULL,
        TEXT("Constant常量表丢失！"),
        NULL
    );

    int constant_elements_table_index;

    if (ret == COMMENT_CREATOR_SUCCESS_ONE) {
        constant_elements_table_index = lua_gettop(L);

        if (bIsNew) {

            for (struct LuaEasyX_Constant* p = (struct LuaEasyX_Constant*)lex_constant_elements;
                    p->ConstantName; p++) {
                //
                lua_pushstring(L, p->ConstantName);
                lua_pushinteger(L, (lua_Integer)(p->uConstantValue));
                lua_settable(L, constant_elements_table_index);
            }

            //
            lua_pushliteral(L, "__call");
            lua_pushcfunction(L, l_GetConstantByName);
            lua_settable(L, constant_elements_table_index);

            lua_pushvalue(L, constant_elements_table_index);
            lua_setmetatable(L, constant_elements_table_index);

            lua_settop(L, constant_elements_table_index);
        }
    } else {
        lua_settop(L, top);
        return 0;
    }

    return 1;
}


LUAEASYX_EXPORT int luaopen_Constant(lua_State* L) {
    return CreateConstant(L);
}

